#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <pthread.h>

/* Global variable: accessible to all threads */
int thread_count;

/* Thread Function */
void *Hello(void *rank);


int main(int argc, char *argv[]) {

  long thread; /* same size as void pointer for casting */
  pthread_t *thread_handles;

  /* Check for right number of arguments */
  if (argc < 2)
    {
      printf("Usage: ./pth_hello <num threads>\nAborting.\n");
      return -1;
    }
  
  /* Get number of threads from command line */
  thread_count = atoi(argv[1]);

  /* create handle array */
  thread_handles = malloc (thread_count * sizeof(pthread_t));

  for (thread = 0; thread < thread_count; thread++)
    {
    pthread_create(&thread_handles[thread], NULL,
		   Hello, (void *)thread);
    }

  printf("Hello from the main thread\n");

  for (thread = 0; thread < thread_count; thread++)
    {
      pthread_join(thread_handles[thread], NULL);
    }
  
  /* clean up */
  free(thread_handles);
  return 0;
} /* main */


/* Thread Function */
void *Hello(void *rank){

  long my_rank = (long) rank;

  printf("Hello from thread %ld of %d\n", my_rank, thread_count);

  return NULL;
} /* Hello */
